Bug 1009601 - add support for STT_GNU_IFUNC for armv7hl
add support for STT_GNU_IFUNC for armv7hl
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: prelink (Show other bugs)
20
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
:
Depends On: 1013801
Blocks: 1106671
  Show dependency treegraph
 
Reported: 2013-09-18 12:54 EDT by Kyle McMartin
Modified: 2015-08-31 23:54 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-06-29 08:24:13 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
add support for ifunc in prelink on arm (4.57 KB, patch)
2013-09-18 12:54 EDT, Kyle McMartin
no flags Details | Diff
/mnt/jakub/jakub/prelink-arm-ifunc.patch (6.97 KB, patch)
2013-10-01 05:27 EDT, Jakub Jelinek
no flags Details | Diff
Updated patch with fixed ifunc.h bits (7.40 KB, text/plain)
2014-04-30 11:37 EDT, Julian Brown
no flags Details

  None (edit)
Description Kyle McMartin 2013-09-18 12:54:41 EDT
Created attachment 799487 [details]
add support for ifunc in prelink on arm

Add STT_GNU_IFUNC support on arm to prelink. Seems to pass test-suite.

Some ARM cpus don't support the BX instruction, so I used mov pc,lr instead.
Comment 1 Jakub Jelinek 2013-10-01 05:27:28 EDT
Created attachment 805779 [details]
/mnt/jakub/jakub/prelink-arm-ifunc.patch

That doesn't look sufficient, I'd expect you need something like this, but have no way to test it right now (blocked on #1013801).
Comment 2 Mark Wielaard 2014-01-25 16:13:57 EST
I noticed this on an arm f20 upgrade. prelink-0.5.0-1.fc20.armv7hl will complain:
/usr/sbin/prelink: /usr/lib/libc-2.18.so: Unknown arm relocation type 160

Where 160 is the value of R_ARM_IRELATIVE.
Comment 3 Julian Brown 2014-04-30 11:37:57 EDT
Created attachment 891210 [details]
Updated patch with fixed ifunc.h bits
Comment 4 Julian Brown 2014-04-30 12:13:04 EDT
My comments on the above patch appear to have been lost: it's an updated version of the patch from this issue. It requires a glibc patch in order for prelinked binaries to execute correctly:

https://sourceware.org/ml/libc-alpha/2014-04/msg00680.html
Comment 5 Fedora End Of Life 2015-05-29 05:25:12 EDT
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 6 Fedora End Of Life 2015-06-29 08:24:13 EDT
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.